﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
//
using OfficeIVS;

namespace AssistToolDialog
{
    public class MainWindowViewModel : INotifyPropertyChanged
    {
        #region フィールド

    	private readonly IList<FontInfo> _ivsFontInfos;

        #endregion

        #region コンストラクタ

        /// <summary>
        /// コンストラクタ
        /// </summary>
        public MainWindowViewModel()
        {
        	_ivsFontInfos = FontManager.GetIvsFontInfos();
        }

        #endregion

        #region OnPropertyChanged

        /// <summary>
        /// プロパティ変更イベント
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged = delegate { };

        /// <summary>
        /// プロパティが変更されたら通知を行います
        /// </summary>
        /// <param name="name">プロパティ名</param>
        protected void OnPropertyChanged(string name)
        {
            PropertyChanged(this, new PropertyChangedEventArgs(name));
        }

        #endregion

        #region プロパティ

        /// <summary>
        /// フォント一覧
        /// </summary>
        public IList<FontInfo> IvsFontInfos
        {
            get { return _ivsFontInfos; }
        }

        #endregion

    }
}
