﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Text;
using Office = Microsoft.Office.Core;
using Microsoft.Office.Tools.Excel;
using System.Windows.Forms;

// TODO: リボン (XML) アイテムを有効にするには、次の手順に従います。

// 1: 次のコード ブロックを ThisAddin、ThisWorkbook、ThisDocument のいずれかのクラスにコピーします。

//  protected override Microsoft.Office.Core.IRibbonExtensibility CreateRibbonExtensibilityObject()
//  {
//      return new MainRibbon();
//  }

// 2. ボタンのクリックなど、ユーザーの操作を処理するためのコールバック メソッドを、このクラスの
//    "リボンのコールバック" 領域に作成します。メモ: このリボンがリボン デザイナーからエクスポートされたものである場合は、
//    イベント ハンドラー内のコードをコールバック メソッドに移動し、リボン拡張機能 (RibbonX) のプログラミング モデルで
//    動作するように、コードを変更します。

// 3. リボン XML ファイルのコントロール タグに、コードで適切なコールバック メソッドを識別するための属性を割り当てます。  

// 詳細については、Visual Studio Tools for Office ヘルプにあるリボン XML のドキュメントを参照してください。


namespace Excel2007IvsAddin
{
    [ComVisible(true)]
    public class MainRibbon : Office.IRibbonExtensibility
    {
        private Office.IRibbonUI ribbon;

        public MainRibbon()
        {
        }

        #region IRibbonExtensibility のメンバー

        public string GetCustomUI(string ribbonID)
        {
            return GetResourceText("Excel2007IvsAddin.MainRibbon.xml");
        }

        #endregion

        #region リボンのコールバック
        //ここにコールバック メソッドを作成します。コールバック メソッドの追加の詳細については、ソリューション エクスプローラーでリボンの XML アイテムを選択し、F1 キーを押してください

        public void Ribbon_Load(Office.IRibbonUI ribbonUI)
        {
            this.ribbon = ribbonUI;
        }

        #endregion

        #region ヘルパー

        private static string GetResourceText(string resourceName)
        {
            Assembly asm = Assembly.GetExecutingAssembly();
            string[] resourceNames = asm.GetManifestResourceNames();
            for (int i = 0; i < resourceNames.Length; ++i)
            {
                if (string.Compare(resourceName, resourceNames[i], StringComparison.OrdinalIgnoreCase) == 0)
                {
                    using (StreamReader resourceReader = new StreamReader(asm.GetManifestResourceStream(resourceNames[i])))
                    {
                        if (resourceReader != null)
                        {
                            return resourceReader.ReadToEnd();
                        }
                    }
                }
            }
            return null;
        }

        #endregion

        public void onIvsInputFormButton(Office.IRibbonControl control)
        {
            Globals.ThisAddIn.IvsInputFormButtonClick();
        }

        public void myCopy(Office.IRibbonControl control, ref bool CancelDefault)
        {
            DataObject dataObj = Globals.ThisAddIn.ExcelHelper.ClipboardCopyFromExcel(Globals.ThisAddIn.Application, ref CancelDefault);
        }

        public void myCut(Office.IRibbonControl control, ref bool CancelDefault)
        {
            DataObject dataObj = Globals.ThisAddIn.ExcelHelper.ClipboardCutFromExcel(Globals.ThisAddIn.Application, ref CancelDefault);
        }

        public void myPaste(Office.IRibbonControl control, ref bool CancelDefault)
        {
            DataObject dataObj = Globals.ThisAddIn.ExcelHelper.ClipboardPasteToExcel(Globals.ThisAddIn.Application, ref CancelDefault);
        }

        public void Ivs2EudcButton(Office.IRibbonControl control)
        {
            if (Globals.ThisAddIn.Application.ActiveWorkbook != null)
            {
                Workbook wb = Globals.Factory.GetVstoObject(Globals.ThisAddIn.Application.ActiveWorkbook);
                Globals.ThisAddIn.ExcelHelper.Ivs2Eudc(wb);
            }
        }

        public void Eudc2IvsButton(Office.IRibbonControl control)
        {
            if (Globals.ThisAddIn.Application.ActiveWorkbook != null)
            {
                Workbook wb = Globals.Factory.GetVstoObject(Globals.ThisAddIn.Application.ActiveWorkbook);
                Globals.ThisAddIn.ExcelHelper.Eudc2Ivs(wb);
            }
        }

        public void mySave(Office.IRibbonControl control, ref bool CancelDefault)
        {
            Workbook wb = Globals.Factory.GetVstoObject(Globals.ThisAddIn.Application.ActiveWorkbook);
            Globals.ThisAddIn.ExcelHelper.SaveEvent(wb, control, ref CancelDefault);
        }

        public bool GetVisible(Office.IRibbonControl control)
        {
            bool ret = true;
            switch (control.Id)
            {
                case "Ivs2Eudc":
                case "Eudc2Ivs":
#if DEBUG
                    ret = true;
#else
                    ret = false;
#endif
                    break;
                default:
                    ret = true;
                    break;
            }

            return ret;
        }
    }
}
