﻿namespace OfficeIVS
{


	/// <summary>
	/// 異体字セレクタ付き文字情報を表します。
	/// </summary>
	public sealed class IvCharInfo
	{
		#region コンストラクタ

		/// <summary>
		/// 新しい <see cref="IvCharInfo"/> 型のインスタンスを初期化します。
		/// </summary>
		internal IvCharInfo() { }

		#endregion

		#region プロパティ

		/// <summary>
		/// 本オブジェクトが表す異体字セレクタ付き文字が属する IVD コレクション名を取得します。
		/// </summary>
		/// <value>IVD コレクション名。</value>
		public string IvdCollectionName { get; internal set; }

		/// <summary>
		/// 異体字セレクタ付き文字を取得します。
		/// </summary>
		/// <value>異体字セレクタ付き文字。</value>
		public string Code { get; internal set; }

		/// <summary>
		/// 異体字セレクタ付き文字のグリフ名を取得します。
		/// </summary>
		/// <value>グリフ名。</value>
		public string GlyphName { get; internal set; }

		/// <summary>
		/// フォント内のグリフ番号を取得します。
		/// </summary>
		/// <value>グリフ番号。</value>
		public ushort GlyphIndex { get; internal set; }

		#endregion
	}
}