﻿using System;
using Office = Microsoft.Office.Core;
using PowerPoint = Microsoft.Office.Interop.PowerPoint;

namespace IvsAddinCommon
{
    public partial class PowerPointHelper
    {
        private PowerPoint.PpSaveAsFileType FilterIndex2FileType(Office.FileDialog fd)
        {
            PowerPoint.PpSaveAsFileType ret;

            switch (fd.FilterIndex)
            {
                case 1:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsOpenXMLPresentation;
                    break;
                case 2:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsOpenXMLPresentationMacroEnabled;
                    break;
                case 3:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsPresentation;
                    break;
                case 4:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsPDF;
                    break;
                case 5:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsXPS;
                    break;
                case 6:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsOpenXMLTemplate;
                    break;
                case 7:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsOpenXMLTemplateMacroEnabled;
                    break;
                case 8:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsTemplate;
                    break;
                case 9:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsOpenXMLTheme;
                    break;
                case 10:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsOpenXMLShow;
                    break;
                case 11:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsOpenXMLShowMacroEnabled;
                    break;
                case 12:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsShow;
                    break;
                case 13:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsOpenXMLAddin;
                    break;
                case 14:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsAddIn;
                    break;
                case 15:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsXMLPresentation;
                    break;
                case 16:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsWebArchive;
                    break;
                case 17:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsHTMLDual;
                    break;
                case 18:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsGIF;
                    break;
                case 19:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsJPG;
                    break;
                case 20:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsPNG;
                    break;
                case 21:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsTIF;
                    break;
                case 22:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsBMP;
                    break;
                case 23:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsMetaFile;
                    break;
                case 24:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsEMF;
                    break;
                case 25:
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsRTF;
                    break;
                case 26:
                    //OpenDocument形式(*.odp)
                    ret = PowerPoint.PpSaveAsFileType.ppSaveAsOpenDocumentPresentation;
                    break;
                default:
                    throw new NotImplementedException();
                //break;
            }

            return ret;
        }
    }
}
